﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9
@EndOfDesignText@
#Event: IsValid (TempData As Map) As Boolean
Sub Class_Globals
	Private xui As XUI
	Public mBase As B4XView
	Public CustomListView1 As CustomListView
	Type TxtItem(Old As String, New As String, Tag As B4XPrefItem)
	Type B4XPrefItem (Title As String, ItemType As Int, Extra As Map, _
						Key As String, Required As Boolean, _
						Default As Object, Mask As String, _
						Link As String, ToolTip As String, Options As List)
	Public PrefItems As List
	Public TYPE_BOOLEAN = 1, TYPE_TEXT = 2, TYPE_DATE = 3, TYPE_OPTIONS = 4, TYPE_COLOR = 5, _
		TYPE_SEPARATOR = 6, TYPE_NUMBER = 7, TYPE_PASSWORD = 8, TYPE_SHORTOPTIONS = 9, TYPE_DECIMALNUMBER = 10, TYPE_MULTILINETEXT = 11, _
		TYPE_TIME = 12, TYPE_NUMERICRANGE = 13 As Int
	Public DateTemplate As B4XDateTemplate
	Public Dialog As B4XDialog
	Private RESULT_SHOWING_NESTED_DIALOG As Int = 100
	Private NestedDialogItemIndex As Int
	Private mTitle As Object
	Public SearchTemplate As B4XSearchTemplate
	Private Template As Object
	Public ColorTemplate As B4XColorTemplate
	Private B4XComboBox1 As B4XComboBox
	Public const THEME_DARK = 1, THEME_LIGHT = 2 As Int
	Private mTheme As Int
	Public ItemsBackgroundColor As Int
	Public TextColor As Int
	Public SeparatorBackgroundColor, SeparatorTextColor As Int
	Private mCallback As Object
	Private mEventName As String
	Private lblShortOptions As Label
	Private lblBooleanItem As Label
	Private lblTimeItem As Label
End Sub

Public Sub Initialize (Parent As B4XView, Title As Object, Width As Int, Height As Int)
	Dialog.Initialize(Parent)
	Dialog.VisibleAnimationDuration = 0
	mTitle = Title
	mBase = xui.CreatePanel("mBase")
	mBase.SetLayoutAnimated(0, 0, 0, Width, Height)
	mBase.LoadLayout("ListTemplate")
	mBase.SetColorAndBorder(xui.Color_Transparent, 0, 0, 0)
	CustomListView1.sv.SetColorAndBorder(xui.Color_Transparent, 0, 0, 0)
	CustomListView1.PressedColor = xui.Color_Transparent
	PrefItems.Initialize
	SearchTemplate.Initialize
	SearchTemplate.Resize(500dip, 300dip)
	DateTemplate.Initialize
	Dialog.OverlayColor = xui.Color_Transparent
	#if B4J
	Dim sv As ScrollPane = CustomListView1.sv
	sv.StyleClasses.Add("b4xdialog")
	sv.InnerNode.StyleClasses.Add("b4xdialog")
	#end if
	setTheme(THEME_DARK)
End Sub

Public Sub SetEventsListener(Callback As Object, EventName As String)
	mCallback = Callback
	mEventName = EventName
End Sub

Public Sub getTitle As Object
	Return mTitle
End Sub

Public Sub setTitle(o As Object)
	mTitle = o
End Sub

Public Sub KeyboardHeightChanged (Height As Int)
	If Dialog.Visible Then
		#if B4i
		Dim p As View = CustomListView1.AsView.Parent.Parent
		Dim rel As Int = p.CalcRelativeKeyboardHeight(Height)
		If rel = 0 Then rel = CustomListView1.AsView.Height
		CustomListView1.sv.Height = Min(rel, CustomListView1.AsView.Height)
		#else
		CustomListView1.sv.Height = Min(CustomListView1.AsView.Height, Height - _
			CustomListView1.AsView.Parent.Top - CustomListView1.AsView.Parent.Parent.Top)
		#End If
		For Each v As B4XView In CustomListView1.AsView.GetAllViewsRecursive
			If v.Tag Is B4XFloatTextField Then
				Dim f As B4XFloatTextField = v.Tag
				If f.Focused Then
					Dim index As Int = CustomListView1.GetItemFromView(f.mBase)
					CustomListView1.ScrollToItem(index)
				End If
			End If
		Next
	End If
End Sub

Public Sub BackKeyPressed As Boolean
	If Dialog.Visible Then
		Dialog.Close(xui.DialogResponse_Cancel)
		Return True
	End If
	Return False
End Sub

Public Sub LoadFromJson (Json As String)
	Dim p As JSONParser
	p.Initialize(Json)
	Dim m As Map = p.NextObject
	Dim theme As String = m.GetDefault("Theme", "Dark Theme")
	Select theme
		Case "Dark Theme"
			setTheme(THEME_DARK)
		Case "Light Theme"
			setTheme(THEME_LIGHT)
	End Select
	Dim items As List = m.Get("Items")
	For Each item As Map In items
		Dim key As String = item.Get("key")
		Dim Link As String = item.Get("link")
		Dim ToolTip As String = item.Get("tooltip")
		Dim title As String = item.Get("title")
		Dim required As Boolean = item.Get("required")
		Dim options As List = item.Get("options")
		If options.IsInitialized = False Then
			options.Initialize
		End If
		Dim itemType As String = item.Get("type")
		Dim default As String = item.Get("default")
		Dim mask As String = item.Get("mask")
						'Title As string, ItemType As Int, Key As String, Default As String, Mask As String, Required As Boolean, Options As List
		Dim pi As B4XPrefItem = CreatePrefItem(title, key, default, mask, required, Link, ToolTip, options)
		Select itemType
			Case "Separator"
				pi.ItemType = TYPE_SEPARATOR
				AddSeparator(pi)
			Case "Boolean"
				pi.ItemType = TYPE_BOOLEAN
				AddBooleanItem(pi)
			Case "Text"
				pi.ItemType = TYPE_TEXT
				AddTextItem(pi)
			Case "Date"
				pi.ItemType = TYPE_DATE
				AddDateItem(pi)
			Case "Short Options"
				pi.ItemType = TYPE_SHORTOPTIONS
				AddShortOptionsItem(pi)	', item.Get("options"))
			Case "Color"
				pi.ItemType = TYPE_COLOR
				AddColorItem(pi)
			Case "Number"
				pi.ItemType = TYPE_NUMBER
				AddNumberItem(pi)
			Case "Password"
				pi.ItemType = TYPE_PASSWORD
				AddPasswordItem(pi)
			Case "Options"
				pi.ItemType = TYPE_OPTIONS
				AddOptionsItem(pi)		', item.Get("options"))
			Case "Decimal Number"
				pi.ItemType = TYPE_DECIMALNUMBER
				AddDecimalNumberItem(pi)
			Case "Multiline Text"
				pi.ItemType = TYPE_MULTILINETEXT
'				Dim l As List = item.Get("options")
				If pi.options.IsInitialized = False Or pi.options.Size = 0 Or IsNumber(pi.options.Get(0)) = False Then
					AddMultilineTextItem(pi, 100dip)
				Else
					AddMultilineTextItem(pi, DipToCurrent(pi.Options.Get(0)))
				End If
			Case "Time"
				pi.ItemType = TYPE_TIME
				AddTimeItem(pi)
			Case "Numeric Range"
'				Dim l As List = item.Get("options")
				pi.ItemType = TYPE_NUMERICRANGE
				If pi.Options.IsInitialized = False Or pi.Options.Size < 3 Or _
					IsNumber(pi.Options.Get(0)) = False Or _
					IsNumber(pi.Options.Get(1)) = False Or _
					IsNumber(pi.Options.Get(2)) = False Then
					AddNumericRangeItem(pi, 0, 100, 1)
				Else
					AddNumericRangeItem(pi, pi.Options.Get(0), pi.Options.Get(1), pi.Options.Get(2))
				End If
		End Select
		Dim pi As B4XPrefItem = PrefItems.Get(PrefItems.Size - 1)
		pi.Required = required
	Next
End Sub

Public Sub AddOptionsItem (pi As B4XPrefItem)	
	If pi.Options.IsInitialized Then
		pi.Extra = CreateMap("options": pi.Options)
	End If
	PrefItems.Add(pi)
End Sub

Public Sub AddShortOptionsItem (pi As B4XPrefItem)
	If pi.Options.IsInitialized Then
		pi.Extra = CreateMap("options": pi.Options)
	End If
	PrefItems.Add(pi)
End Sub

Public Sub AddBooleanItem (pi As B4XPrefItem)
	PrefItems.Add(pi)
End Sub

Public Sub AddTextItem (pi As B4XPrefItem)
	PrefItems.Add(pi)
End Sub

Public Sub AddNumberItem (pi As B4XPrefItem)
	PrefItems.Add(pi)
End Sub

Public Sub AddDecimalNumberItem (pi As B4XPrefItem)
	PrefItems.Add(pi)
End Sub

Public Sub AddMultilineTextItem (pi As B4XPrefItem, Height As Int)
	pi.Extra = CreateMap("height": Height)
	PrefItems.Add(pi)
End Sub

Public Sub AddNumericRangeItem (pi As B4XPrefItem, RangeStart As Double, RangeEnd As Double, Interval As Double)
	pi.Extra = CreateMap("start": RangeStart, "end": RangeEnd, "interval": Interval)
	PrefItems.Add(pi)
End Sub

Public Sub AddTimeItem (pi As B4XPrefItem)
	PrefItems.Add(pi)
End Sub

Public Sub AddPasswordItem (pi As B4XPrefItem)
	PrefItems.Add(pi)
End Sub

Public Sub AddDateItem (pi As B4XPrefItem)
	PrefItems.Add(pi)
End Sub

Public Sub AddColorItem(pi As B4XPrefItem)
	If ColorTemplate.IsInitialized = False Then
		ColorTemplate.Initialize
	End If
	PrefItems.Add(pi)
End Sub

Public Sub AddSeparator(pi As B4XPrefItem)
	PrefItems.Add(pi)
End Sub

Private Sub CreatePrefItem(Title As String, Key As String, _
						Default As String, Mask As String, Required As Boolean, _
						Link As String, ToolTip As String, _
						Options As List) As B4XPrefItem
	Dim pi As B4XPrefItem
	pi.Initialize
	pi.Link = Link
	pi.ToolTip = ToolTip
	pi.Title = Title
	pi.Key = Key 
	pi.Default = Default
	pi.Mask = Mask
	pi.Required = Required
	pi.Options = Options
	Return pi
End Sub

'Example:<code>
'Dim Data As Map = CreateMap()
'Wait For (Preferences.ShowDialog(Data, "OK", "CANCEL")) Complete (Result As Int)
'If Result = xui.DialogResponse_Positive Then
'	
'End If</code>
Public Sub ShowDialog (Data As Map, Yes As Object, Cancel As Object) As ResumableSub
	If CustomListView1.Size = 0 Then
		Dim LastTextField As B4XFloatTextField
		For Each pi As B4XPrefItem In PrefItems		'load all the JSON items
			Dim pnl As B4XView = CreateLayouts(pi)
			CustomListView1.Add (pnl, pi)
			If pnl.GetView(0).Tag Is B4XFloatTextField Then
				Dim tf As B4XFloatTextField = pnl.GetView(0).Tag
				If LastTextField.IsInitialized Then
					LastTextField.NextField = tf
				End If
				LastTextField = tf
			End If
		Next
		#if B4A
		'this sets ForceDone to True.
		If LastTextField.IsInitialized Then LastTextField.NextField = LastTextField
		#end if
		
		Dialog.InternalAddStubToCLVIfNeeded(CustomListView1, CustomListView1.DefaultTextBackgroundColor)
	End If
	FillData (Data)
	Dim ScrollViewOffset As Int
	Do While True
		Dialog.Title = mTitle
		Dialog.PutAtTop = xui.IsB4A Or xui.IsB4i
		Dim rs As Object = Dialog.ShowTemplate(Me, Yes, "", Cancel)
		#if B4A
		If ScrollViewOffset > 0 Then
			Sleep(50)
			Dim sv As ScrollView = CustomListView1.sv
			sv.ScrollToNow(ScrollViewOffset)
		End If
		#End If
		Wait For (rs) Complete (Result As Int)	'Here is where it goes to loop thru until OK/CANCEL
		ScrollViewOffset = CustomListView1.sv.ScrollViewOffsetY
		If Result <> RESULT_SHOWING_NESTED_DIALOG Then
			If Result = xui.DialogResponse_Positive Then
				If CommitChanges(Data) = False Then Continue
			End If
			Return Result
		Else
			Dim y As Object
			If Template = ColorTemplate Then y = Yes Else y = ""
			Dialog.PutAtTop = xui.IsB4A Or xui.IsB4i
			'wait for the template response
			Wait For (Dialog.ShowTemplate(Template, y, "", Cancel)) Complete (Result As Int)
			If Result = xui.DialogResponse_Positive Then
				Dim lblValue As B4XView = CustomListView1.GetPanel(NestedDialogItemIndex).GetView(0)				
				Dim lblTitle As B4XView = CustomListView1.GetPanel(NestedDialogItemIndex).GetView(1)				
				Dim value As String
				If Template = DateTemplate Then
					value = DateTime.Date(DateTemplate.Date)
					lblValue.Text = value
				Else if Template = SearchTemplate Then
					lblValue.SetTextAlignment("CENTER", "LEFT")
					value = SearchTemplate.SelectedItem
					lblValue.Text = value
				Else If Template = ColorTemplate Then
					value = ColorTemplate.SelectedColor
					SetLabelColor(lblValue, value)
				End If
			End If
		End If
	Loop
	Return -1 'never happens
End Sub

Public Sub GetPanel (Dialog1 As B4XDialog) As B4XView
	Return mBase
End Sub

Private Sub Show (Dialog1 As B4XDialog) 'ignore
	
End Sub

Public Sub Clear
	CustomListView1.Clear
	For i = 0 To CustomListView1.Size -1
		Dim vw As Panel = CustomListView1.GetPanel(i)
		vw.RemoveAllViews
	Next
	PrefItems.Clear
End Sub

Private Sub FillData (Data As Map)
	For i = 0 To CustomListView1.Size - 1
		Dim Item As CLVItem = CustomListView1.GetRawListItem(i)
		If (Item.Value Is B4XPrefItem) = False Then Exit
		Dim PrefItem As B4XPrefItem = Item.Value
		Dim ItemPanel As B4XView = Item.Panel.GetView(0)
		Select PrefItem.ItemType
			Case TYPE_BOOLEAN
				Dim switch As B4XSwitch = ItemPanel.GetView(1).Tag
				switch.Value = GetPrefItemValue(PrefItem, PrefItem.Default, Data)
			Case TYPE_TEXT, TYPE_PASSWORD, TYPE_NUMBER, TYPE_DECIMALNUMBER, TYPE_MULTILINETEXT
				Dim ft As B4XFloatTextField = ItemPanel.GetView(0).Tag
				ft.Text = GetPrefItemValue(PrefItem, "", Data)
			Case TYPE_DATE
				ItemPanel.GetView(1).Text = DateTime.Date(GetPrefItemValue(PrefItem, DateTime.Now, Data))
			Case TYPE_OPTIONS
				ItemPanel.GetView(0).Text = GetPrefItemValue(PrefItem, "", Data)
			Case TYPE_SHORTOPTIONS
				Dim cmb As B4XComboBox = ItemPanel.GetView(1).Tag
				Dim options As List = PrefItem.Extra.Get("options")
				cmb.SelectedIndex = Max(0, options.IndexOf(GetPrefItemValue(PrefItem, "", Data)))
			Case TYPE_COLOR
				SetLabelColor(ItemPanel.GetView(1), GetPrefItemValue(PrefItem, xui.Color_Red, Data))
			Case TYPE_TIME
				Dim pmHours As B4XPlusMinus = ItemPanel.GetView(0).Tag
				Dim pmMinutes As B4XPlusMinus = ItemPanel.GetView(1).Tag
				Dim pmAMPM As B4XPlusMinus = ItemPanel.GetView(2).Tag
				Dim p As Period
				p = GetPrefItemValue(PrefItem, p, Data)
				Dim hour As Int = p.Hours
				Dim m As String
				If hour <= 11 Then
					m = "am"
				Else
					m = "pm"
					hour = hour - 12
				End If
				If hour = 0 Then hour = 12
				pmHours.SelectedValue = hour
				pmMinutes.SelectedValue = p.Minutes
				pmAMPM.SelectedValue = m
			Case TYPE_SEPARATOR
			Case TYPE_NUMERICRANGE
				Dim pm As B4XPlusMinus = ItemPanel.GetView(0).Tag
				pm.SelectedValue = GetPrefItemValue(PrefItem, 0, Data)
			Case Else
				Log("Unknown type: " & PrefItem.ItemType)
		End Select
	Next
End Sub

Private Sub SetLabelColor(lbl As B4XView, clr As Int)
	lbl.SetColorAndBorder(clr, 1dip, Dialog.BorderColor, 5dip)
End Sub

Private Sub GetPrefItemValue (PrefItem As B4XPrefItem, DefaultValue As Object, Data As Map) As Object
	Return Data.GetDefault(PrefItem.Key, DefaultValue)
End Sub

Public Sub getTheme As Int
	Return mTheme
End Sub

Public Sub setTheme (t As Int)
	If t <> mTheme Then
		mTheme = t
		CustomListView1.Clear
		Dim DividerColor As Int
		Select mTheme
			Case THEME_DARK
				ItemsBackgroundColor = 0xFF626262
				SeparatorBackgroundColor = 0xFFC0C0C0
				SeparatorTextColor = xui.Color_Black
				TextColor = xui.Color_White
				DividerColor = 0xFF464646
				Dialog.BackgroundColor = 0xFF555555
				Dialog.ButtonsColor = 0xFF555555
				Dialog.BorderColor = 0xff000000
				Dialog.ButtonsTextColor = 0xFF89D5FF
				DateTemplate.DaysInWeekColor = xui.Color_Gray
				DateTemplate.SelectedColor = 0xFF0BA29B
			Case THEME_LIGHT
				ItemsBackgroundColor = xui.Color_White
				SeparatorBackgroundColor = 0xFFD0D0D0
				SeparatorTextColor = 0xFF4E4F50
				TextColor = 0xFF5B5B5B
				DividerColor = 0xFFDFDFDF
				Dialog.BackgroundColor = xui.Color_White
				Dialog.ButtonsColor = xui.Color_White
				Dialog.BorderColor = xui.Color_Gray
				Dialog.ButtonsTextColor = 0xFF007DC3
				DateTemplate.DaysInWeekColor = xui.Color_Black
				DateTemplate.SelectedColor = 0xFF39D7CE
				
		End Select
		SearchTemplate.SearchField.TextField.TextColor = TextColor
		SearchTemplate.SearchField.NonFocusedHintColor = TextColor
'		SearchTemplate.SearchField.lblV.Width = 500dip
'		CustomListView1.AsView.Width = 500dip
		Dialog.BorderCornersRadius = 0
		Dialog.BorderWidth = 1dip
		DateTemplate.HighlightedColor = 0xFF00CEFF
		DateTemplate.DaysInMonthColor = TextColor
		DateTemplate.lblMonth.TextColor = TextColor
		DateTemplate.lblYear.TextColor = TextColor
		For Each clv As CustomListView In Array(CustomListView1, SearchTemplate.CustomListView1)
			clv.sv.ScrollViewInnerPanel.Color = DividerColor
			clv.sv.Color = Dialog.BackgroundColor
			clv.DefaultTextBackgroundColor = ItemsBackgroundColor
			clv.DefaultTextColor = TextColor
			#if B4J
			Dim sv As Node = clv.sv
			sv.StyleClasses.Clear
			sv.StyleClasses.Add("b4xdialog")
			If mTheme = THEME_LIGHT Then sv.StyleClasses.Add("b4xdialoglight")
			#End if
		Next
		For Each b As B4XView In Array(DateTemplate.btnMonthLeft, DateTemplate.btnMonthRight, DateTemplate.btnYearLeft, DateTemplate.btnYearRight)
			b.Color = xui.Color_Transparent
			b.TextColor = TextColor
		#if B4i
			Dim no As NativeObject = b
			no.RunMethod("setTitleColor:forState:", Array(no.ColorToUIColor(TextColor), 0))
		#End If
		Next
	End If
End Sub

Private Sub B4XFloatTextField1_EnterPressed
	Dim B4xFld As B4XFloatTextField
	B4xFld = Sender
	Dim edtText As EditText = B4xFld.TextField
	Dim p As B4XView = B4xFld.TextField.Parent.parent
	Dim tg As B4XPrefItem = p.Tag
	If SubExists(Main, "Text_EnterPressed") Then
		CallSub3(Main, "Text_EnterPressed", edtText, tg)
	End If
End Sub

private Sub B4XFloatTextField1_TextChanged (Old As String, New As String) 	'text/multiline text
	Dim B4xFld As B4XFloatTextField
	B4xFld = Sender
	Dim p As B4XView = B4xFld.TextField.Parent.parent
	Dim This As TxtItem
	This.Tag = p.Tag
	This.Old = Old
	This.New = New
	Log("TEXT CHANGED " & Old & "   new " & New)		'also password
	If SubExists(Main, "Text_Changing") Then
		CallSub2(Main, "Text_Changing", This)
	End If
End Sub

Private Sub B4XSwitch1_ValueChanged (Value As Boolean)	'boolean
	Dim Switch As B4XSwitch
	Switch = Sender
	Dim p As Panel = Switch.mBase.Parent
	Dim lbl As Label = p.GetView(0)	'label for the switch
	Dim Tag As B4XPrefItem = lbl.Tag
	CallSub3(Main, "SetToolTip", Tag.ToolTip, Value)
	If SubExists(Main, "Boolean_Changed") Then
		CallSub3(Main, "Boolean_Changed", Value, Tag)
	End If
End Sub

Sub lblBooleanItem_Click
	Dim lbl As Label
	lbl = Sender
	Dim Tag As B4XPrefItem = lbl.Tag
	CallSub3(Main, "SetToolTip", Tag.ToolTip, "")
End Sub

Private Sub PM_ValueChanged (Value As Object)			'Plus Minus/range
	If SubExists(Main, "PM_Changed") Then
		CallSub2(Main, "PM_Changed", Value)
	End If
End Sub

Private Sub pmHours_ValueChanged (Value As Object)
	If SubExists(Main, "PMHours_Changed") Then
		CallSub2(Main, "PMHours_Changed", Value)
	End If
End Sub

Private Sub pmMinutes_ValueChanged (Value As Object)
	If SubExists(Main, "PMMinutes_Changed") Then
		CallSub2(Main, "PMMinutes_Changed", Value)
	End If
End Sub

Sub lblTimeItem_Click
	Dim lbl As Label
	lbl = Sender
	Dim Tag As B4XPrefItem = lbl.Tag
	CallSub3(Main, "SetToolTip", Tag.ToolTip, "")
End Sub

Private Sub pmAMPM_ValueChanged (Value As Object)
	If SubExists(Main, "PMAMPM_Changed") Then
		CallSub2(Main, "PMAMPM_Changed", Value)
	End If
End Sub

Private Sub B4XComboBox1_SelectedIndexChanged (Index As Int)
	If SubExists(Main, "B4xComboBox_Changed") Then
		Dim Value As String = B4XComboBox1.GetItem(Index)
		CallSub3(Main, "B4xComboBox_Changed", Index, Value)
	End If
End Sub

Sub lblShortOptions_Click
	Dim lbl As Label
	lbl = Sender
	Dim Tag As B4XPrefItem = lbl.Tag
	CallSub3(Main, "SetToolTip", Tag.ToolTip, "")
End Sub

Private Sub CreateLayouts (pi As B4XPrefItem) As B4XView
	Dim p As B4XView = xui.CreatePanel("")
	p.Width = CustomListView1.sv.ScrollViewContentWidth
	p.Height = 50dip
	Select pi.ItemType
		Case TYPE_BOOLEAN
			p.LoadLayout("booleanitem")
			Dialog.InternalSetTextOrCSBuilderToLabel(p.GetView(0), pi.Title)
			p.GetView(0).TextColor = TextColor
			p.GetView(0).Tag = pi
''Log(p.GetView(0).Text)
''Log(p.GetView(0).Tag)
		Case TYPE_MULTILINETEXT
			p.Height = pi.Extra.Get("height")
			p.LoadLayout("textitemmulti")
			p.Tag = pi
			Dim ft As B4XFloatTextField = p.GetView(0).Tag
			ft.HintText = pi.Title
			ft.Update
		Case TYPE_TIME
			CreateTimeItem(pi, p)
		Case TYPE_NUMERICRANGE
			CreateNumericRangeItem(pi, p)
		Case TYPE_TEXT, TYPE_PASSWORD, TYPE_NUMBER, TYPE_DECIMALNUMBER
			p.Height = 60dip
			
			If pi.ItemType = TYPE_PASSWORD Then
				p.LoadLayout("passworditem")
				p.Tag = pi
			Else
				p.LoadLayout("textitem")
				p.Tag = pi
				Dim ft As B4XFloatTextField = p.GetView(0).Tag
				If pi.ItemType = TYPE_NUMBER Then
					#if B4A
					Dim et As EditText = ft.TextField
					et.InputType = et.INPUT_TYPE_NUMBERS
					#else if B4I
					Dim ttf As TextField = ft.TextField
					ttf.KeyboardType = ttf.TYPE_NUMBER_PAD
					#End If
				Else If pi.ItemType = TYPE_DECIMALNUMBER Then
					#if B4A
					Dim et As EditText = ft.TextField
					et.InputType = et.INPUT_TYPE_DECIMAL_NUMBERS
					#else if B4I
					Dim ttf As TextField = ft.TextField
					ttf.KeyboardType = ttf.TYPE_NUMBERS_AND_PUNCTUATIONS
					#End If
				End If
			End If
			
			Dim ft As B4XFloatTextField = p.GetView(0).Tag
			ft.HintText = pi.Title
			ft.Update
		Case TYPE_DATE
			TwoLabelsLayout("lblDate", p, pi)
		Case TYPE_OPTIONS
			TwoLabelsLayout("lblOptions", p, pi)
		Case TYPE_SHORTOPTIONS
			p.LoadLayout("shortoptions")
			p.GetView(0).TextColor = TextColor
			Dim original As List = pi.Extra.Get("options")
			#if B4i
			Dim no As NativeObject = B4XComboBox1.mBtn
			B4XComboBox1.mBtn.Font = xui.CreateDefaultBoldFont(16)
			no.RunMethod("setTitleColor:forState:", Array(no.ColorToUIColor(TextColor), 0))
			no.SetField("contentHorizontalAlignment", 2) 'right
			#end if
			#if B4A
			Dim spnr As Spinner = B4XComboBox1.cmbBox
			spnr.TextColor = TextColor
			spnr.DropdownBackgroundColor = Dialog.BackgroundColor
			SetBackgroundTintList(spnr, xui.Color_Gray, TextColor)
			Dim options As List
			options.Initialize
			Dim cs As CSBuilder
			For Each opt As String In original
				options.Add(cs.Initialize.Alignment("ALIGN_OPPOSITE").Typeface(Typeface.DEFAULT_BOLD).Append(opt).PopAll)
			Next
			B4XComboBox1.SetItems(options)
			#else
			B4XComboBox1.SetItems(original)
			#End If
			Dialog.InternalSetTextOrCSBuilderToLabel(p.GetView(1), pi.Title)
		Case TYPE_COLOR
			TwoLabelsLayout("lblColors", p, pi)
		Case TYPE_SEPARATOR
			Dim lbl As Label
			lbl.Initialize("")
			Dim xlbl As B4XView = lbl
			xlbl.SetTextAlignment("CENTER", "CENTER")
			xlbl.TextColor = SeparatorTextColor
			xlbl.Font = xui.CreateDefaultBoldFont(14)
			xlbl.Color = SeparatorBackgroundColor
			p.Height = 30dip
			p.AddView(xlbl, 0, 0, p.Width, p.Height)
			Dialog.InternalSetTextOrCSBuilderToLabel(xlbl, pi.Title)
			pi.Required = False
			p.Tag = pi
	End Select
	If pi.Required Then
		Dim rlbl As Label
		rlbl.Initialize("")
		Dim xlbl As B4XView = rlbl
		xlbl.Text = "*"
		xlbl.TextColor = xui.Color_Red
		xlbl.TextSize = 11
		xlbl.SetTextAlignment("TOP", "LEFT")
		p.AddView(xlbl, 01dip, 0dip, 10dip, 10dip)
	End If
	p.Color = ItemsBackgroundColor
	If mTheme <> THEME_DARK Then
		If p.GetView(0).Tag Is B4XFloatTextField Then
			Dim tf As B4XFloatTextField = p.GetView(0).Tag
			tf.TextField.TextColor = TextColor
			tf.NonFocusedHintColor = TextColor
			tf.Update
			If tf.lblClear.IsInitialized Then tf.lblClear.TextColor = TextColor
			If tf.lblV.IsInitialized Then tf.lblV.TextColor = TextColor
		End If
	End If
	Return p
End Sub

Private Sub CreateNumericRangeItem (PrefItem As B4XPrefItem, p As B4XView)
	p.LoadLayout("numericrange")
	p.Tag = PrefItem
	Dim pm As B4XPlusMinus = p.GetView(0).Tag
	pm.SetNumericRange(PrefItem.Extra.Get("start"), PrefItem.Extra.Get("end"), PrefItem.Extra.Get("interval"))
	pm.Formatter.GetDefaultFormat.MaximumFractions = 2
	Dialog.InternalSetTextOrCSBuilderToLabel(p.GetView(1), PrefItem.Title)
	For Each v As B4XView In p.GetAllViewsRecursive
		If v Is Label Then v.TextColor = TextColor
	Next
End Sub

Private Sub CreateTimeItem (PrefItem As B4XPrefItem, p As B4XView)
	p.Height = 60dip
	p.LoadLayout("timeitem")
	p.Tag = PrefItem
	Dim pmHours As B4XPlusMinus = p.GetView(0).Tag
	Dim pmMinutes As B4XPlusMinus = p.GetView(1).Tag
	Dim pmAMPM As B4XPlusMinus = p.GetView(2).Tag
	If xui.IsB4J = False Then
		Dim clr As Int = CustomListView1.sv.ScrollViewInnerPanel.Color
		pmHours.mBase.SetColorAndBorder(xui.Color_Transparent, 1dip, clr, 0)
		pmMinutes.mBase.SetColorAndBorder(xui.Color_Transparent, 1dip, clr, 0)
		pmAMPM.mBase.SetColorAndBorder(xui.Color_Transparent, 1dip, clr, 0)
	End If
	pmHours.SetNumericRange(1, 12, 1)
	pmMinutes.SetNumericRange(0, 59, 1)
	pmMinutes.Formatter.GetDefaultFormat.MinimumIntegers = 2
	
	pmAMPM.SetStringItems(Array("am", "pm"))
	Dialog.InternalSetTextOrCSBuilderToLabel(p.GetView(3), PrefItem.Title)
	For Each v As B4XView In p.GetAllViewsRecursive
		If v Is Label Then v.TextColor = TextColor
	Next
End Sub

'return True if valid
Private Sub CommitChanges (Data As Map) As Boolean
	Dim Temp As Map
	Temp.Initialize
	For i = 0 To CustomListView1.Size - 1
		Dim Item As CLVItem = CustomListView1.GetRawListItem(i)
		If (Item.Value Is B4XPrefItem) = False Then Exit
		Dim PrefItem As B4XPrefItem = Item.Value
		Dim ItemPanel As B4XView = Item.Panel.GetView(0)
		Dim Required As Boolean = PrefItem.Required
		Dim Value As Object
		Select PrefItem.ItemType
			Case TYPE_BOOLEAN
				Dim switch As B4XSwitch = ItemPanel.GetView(1).Tag
				Value = switch.Value
			Case TYPE_TEXT, TYPE_PASSWORD, TYPE_MULTILINETEXT
				Dim ft As B4XFloatTextField = ItemPanel.GetView(0).Tag
				Value = ft.Text
				
			Case TYPE_NUMBER, TYPE_DECIMALNUMBER
				Dim ft As B4XFloatTextField = ItemPanel.GetView(0).Tag
				Dim n As Double
				If ft.Text <> "" Then
					If IsNumber(ft.Text) Then
						n = ft.Text
						If PrefItem.ItemType = TYPE_NUMBER Then
							Dim n2 As Int = n
							Value = n2
						Else
							Value = n
						End If
					Else
						GoToItem(i)
						Return False
					End If
				Else
					Value = ""
				End If
			Case TYPE_DATE
				Value = DateTime.DateParse(ItemPanel.GetView(1).Text)
			Case TYPE_TIME
				Dim pmHours As B4XPlusMinus = ItemPanel.GetView(0).Tag
				Dim pmMinutes As B4XPlusMinus = ItemPanel.GetView(1).Tag
				Dim pmAMPM As B4XPlusMinus = ItemPanel.GetView(2).Tag
				Dim p As Period
				p.Initialize
				p.Hours = pmHours.SelectedValue
				If p.Hours = 12 Then p.Hours = 0
				If pmAMPM.SelectedValue = "pm" Then p.Hours = p.Hours + 12
				p.Minutes = pmMinutes.SelectedValue
				Value = p
			Case TYPE_NUMERICRANGE
				Dim pm As B4XPlusMinus = ItemPanel.GetView(0).Tag
				Value = pm.SelectedValue
			Case TYPE_OPTIONS
				Value = ItemPanel.GetView(1).Text
			Case TYPE_SHORTOPTIONS
				Dim cmb As B4XComboBox = ItemPanel.GetView(1).Tag
				If cmb.SelectedIndex > -1 Then Value = cmb.GetItem(cmb.SelectedIndex) Else Value = ""
			Case TYPE_COLOR
				Value = ItemPanel.GetView(1).Color
			Case TYPE_SEPARATOR
				Continue
		End Select
		If Value = "" Then
			If Required Then
				GoToItem(i)
				Return False
			Else
				Continue
			End If
		End If
		Temp.Put(PrefItem.Key, Value)
	Next
	If mEventName <> "" And xui.SubExists(mCallback, mEventName  & "_IsValid", 1) Then
		Dim Valid As Boolean = CallSub2(mCallback, mEventName & "_IsValid", Temp)
		If Valid = False Then Return False
	End If
	For Each key As String In Temp.Keys
		Data.Put(key, Temp.Get(key))
	Next
	Return True
End Sub

'Scrolls to the item and shows a "shake" animation.
Public Sub ScrollToItemWithError (key As String)
	For i = 0 To CustomListView1.Size - 1
		Dim Item As CLVItem = CustomListView1.GetRawListItem(i)
		Dim PrefItem As B4XPrefItem = Item.Value
		If PrefItem.Key = key Then
			GoToItem(i)
			Return
		End If
	Next
End Sub

Private Sub GoToItem (i As Int)
	CustomListView1.JumpToItem(i)
	Dim p As B4XView = CustomListView1.GetPanel(i)
	For i = 0 To 3
		Dim duration As Int = 100 - i * 20
		p.SetLayoutAnimated(duration, -10dip, 0, p.Width, p.Height)
		Sleep(duration)
		p.SetLayoutAnimated(duration, 10dip, 0, p.Width, p.Height)
		Sleep(duration)
	Next
	p.SetLayoutAnimated(50, 0, 0, p.Width, p.Height)
End Sub

Private Sub TwoLabelsLayout (EventName As String, p As B4XView, PrefItem As B4XPrefItem)
	Dim lblDate As B4XView = CreateLabel(EventName)
	lblDate.SetTextAlignment("CENTER", "LEFT")
	lblDate.TextColor = TextColor
'	Dim fnt As B4XFont = xui.CreateDefaultBoldFont(16)
'	lblDate.Font = fnt
	Dialog.InternalSetTextOrCSBuilderToLabel(lblDate, PrefItem.Title)
	p.AddView(lblDate, 10dip, 10dip, p.Width - 110dip, 30dip)
	Dim lblTitle As B4XView = CreateLabel(EventName)
	lblTitle.TextColor = TextColor
	lblTitle.SetTextAlignment("CENTER", "RIGHT")
'	lblTitle.Font = fnt
	Dialog.InternalSetTextOrCSBuilderToLabel(lblTitle, PrefItem.Title)
	p.AddView(lblTitle, p.Width - 108dip, 10dip, 98dip, 30dip)
	p.Tag = PrefItem
End Sub

#if B4J
Private Sub lblOptions_MouseClicked (EventData As MouseEvent)
	EventData.Consume
#else
Private Sub lblOptions_Click
#end if
	NestedDialogItemIndex = CustomListView1.GetItemFromView(Sender)
	Dim pref As B4XPrefItem = CustomListView1.GetValue(NestedDialogItemIndex)
	Dialog.Title = pref.Title
	If pref.Extra.ContainsKey("index") Then
		SearchTemplate.SetIndex(pref.Extra.Get("index"))
	Else
		pref.Extra.Put("index", SearchTemplate.SetItems(pref.Extra.Get("options")))
	End If
	SearchTemplate.SelectedItem = CustomListView1.GetPanel(NestedDialogItemIndex).GetView(1).Text
	Template = SearchTemplate
	Dialog.Close(RESULT_SHOWING_NESTED_DIALOG)
End Sub

#if B4J
Private Sub lblDate_MouseClicked (EventData As MouseEvent)
	EventData.Consume
#else
Private Sub lblDate_Click
#end If
	NestedDialogItemIndex = CustomListView1.GetItemFromView(Sender)
	Dim pref As B4XPrefItem = CustomListView1.GetValue(NestedDialogItemIndex)
	Dialog.Title = pref.Title
	DateTemplate.Date = DateTime.DateParse(CustomListView1.GetPanel(NestedDialogItemIndex).GetView(1).Text)
	Template = DateTemplate
	Dialog.Close(RESULT_SHOWING_NESTED_DIALOG)
End Sub

#if B4J
Private Sub lblColors_MouseClicked (EventData As MouseEvent)
	EventData.Consume
#else
Private Sub lblColors_Click
#end if
	NestedDialogItemIndex = CustomListView1.GetItemFromView(Sender)
	Dim pref As B4XPrefItem = CustomListView1.GetValue(NestedDialogItemIndex)
	Dialog.Title = pref.Title
	ColorTemplate.SelectedColor = CustomListView1.GetPanel(NestedDialogItemIndex).GetView(1).Color
	Template = ColorTemplate
	Dialog.Close(RESULT_SHOWING_NESTED_DIALOG)
End Sub

Private Sub CreateLabel(EventName As String) As B4XView
	Dim lbl As Label
	lbl.Initialize(EventName)
	Return lbl
End Sub

'Sets the options of a preference item
Public Sub SetOptions (Key As String, Options As List)
	Dim pi As B4XPrefItem = GetPrefItem(Key)
	If pi.Extra.IsInitialized = False Then
		pi.Extra.Initialize
	End If
	pi.Extra.Put("options", Options)
End Sub

Private Sub GetPrefItem (Key As String) As B4XPrefItem
	For Each pi As B4XPrefItem In PrefItems
		If pi.Key = Key Then Return pi
	Next
	Return Null
End Sub

Private Sub DialogClosed(Result As Int) 'ignore
	
End Sub

#if B4A
'Private Sub SetSearchTextSize
'	Dim TextSize As Float = 25 'FLOAT
'	Dim jo As JavaObject = SearchTemplate.CustomListView1
'	jo.GetFieldJO("_designerlabel").RunMethod("setTextSize", Array(TextSize))
'End Sub

Private Sub SetBackgroundTintList(View As View,Active As Int, Enabled As Int)
	Dim States(2,1) As Int
	States(0,0) = 16842908     'Active
	States(1,0) = 16842910    'Enabled
	Dim Color(2) As Int = Array As Int(Active,Enabled)
	Dim CSL As JavaObject
	CSL.InitializeNewInstance("android.content.res.ColorStateList",Array As Object(States,Color))
	Dim jo As JavaObject
	jo.InitializeStatic("android.support.v4.view.ViewCompat")
	jo.RunMethod("setBackgroundTintList", Array(View, CSL))
End Sub
#End If